#include <bits/stdc++.h>
#define MOD 998244353
using namespace std;
long long n,m,B[200000],C,A[99999999];
int main(){
    std::ios_base::sync_with_stdio (false);
    cin>>n>>m;
    for(int i=0;i<m;i++)cin>>B[i];
    cin>>C;
    for(int i=1;i<=n;i++)A[i]=i;
    for(int i=0;i<=n-m;i++){
    for (int j=0; j<m; j++)
        A[i + B[j]] =A[i + j+1];
    }
    long long rez=0;
    for(int i=n;i>0;i--){
        rez+=A[i];
        rez%=MOD;
        rez*=C;
        rez%=MOD;
    }
    cout<<rez;
    return 0;
}